<?php
/**************************************************************************\
* eGroupWare                                                               *
* http://www.egroupware.org                                                *
* --------------------------------------------                             *
*  This program is free software; you can redistribute it and/or modify it *
*  under the terms of the GNU General Public License as published by the   *
*  Free Software Foundation; either version 2 of the License, or (at your  *
*  option) any later version.                                              *
\**************************************************************************/

/**
 * 
 *
 * @package Settings
 * @license http://www.gnu.org/copyleft/gpl.html GPL
 * @author Pedro Eugênio Rocha - pedro.eugenio.rocha@gmail.com
 */

class Settings {

	/**
	 * @var array $_configs Here we should define which settings we are able
	 * 						to get. The settings not defined here will throw
	 * 						an exception when someone asks for it.
	 * @access private
	 */
	private static $_configs = array(
		'workflow' => array(
			'intranet_subnetworks' => '',
			'db' => array(
				'name' => '',
				'host' => '',
				'port' => '',
				'admin_user' => '',
				'admin_password' => '',
				'type' => ''
			),
			'galaxia' => array(
				'db' => array(
					'name' => '',
					'host' => '',
					'port' => '',
					'user' => '',
					'password' => '',
					'type' => ''
				)
			),
			'ldap' => array(
				'host' => '',
				'user' => '',
				'password' => '',
				'follow_referrals' => ''
			),
		),
		'expresso' => array(
			'db' => array(
				'name' => '',
				'host' => '',
				'port' => '',
				'user' => '',
				'password' => '',
				'type' => ''
			),
			'ldap' => array(
				'host' => ''
			),
		),
		'process' => array(
		)
	);

	private static $loaded_from_db = false;


	/**
	 * Constructor. Just disabling direct instantiation.
	 *
	 * @access public
	 * @return void
	 */
	public function __construct() {
		throw new Exception("Oops! Static only class.");
	}


	/**
	 * Returns settings.
	 *
	 * @param string $args 	A variable number of parameters which specify the scope
	 *						and the configuration to be retrieved.
	 * @access public
	 * @return string
	 * @static
	 */
	public static function get() {

		/* getting the variable number of parameters */
		$args = func_get_args();

		/**
		 * Here we check if the configuration was defined into $_configs array.
		 * If it does not, an exception will be thrown.
		 * p.s. Do not try to understand this piece of code. Just fave faith! It works...
		 */
		for ($i=0, $sub_array=&self::$_configs; $i<count($args); $sub_array=&$sub_array[$args[$i++]]) {
			if (!array_key_exists($args[$i], $sub_array))
				throw new Exception("Sorry! Setting '".implode("->", $args)."' do not exists.");
		}

		/* check if the setting was loaded */
		$methodName = "populate" . ucfirst(strtolower($args[0]));
		self::$methodName();


		/* retrieving the setting. More 'for' programming. */
		for ($i=0, $value=&self::$_configs; $i<count($args); $value=&$value[$args[$i++]]);

		return $value;
	}


	public static function load() {

		self::$_configs['expresso']['db']['name'] = $GLOBALS['phpgw_info']['server']['db_name'];
		self::$_configs['expresso']['db']['host'] = $GLOBALS['phpgw_info']['server']['db_host'];
		self::$_configs['expresso']['db']['port'] = $GLOBALS['phpgw_info']['server']['db_port'];
		self::$_configs['expresso']['db']['user'] = $GLOBALS['phpgw_info']['server']['db_user'];
		self::$_configs['expresso']['db']['password'] = $GLOBALS['phpgw_info']['server']['db_pass'];
		self::$_configs['expresso']['db']['type'] = $GLOBALS['phpgw_info']['server']['db_type'];

		self::$_configs['expresso']['ldap']['host'] = $GLOBALS['phpgw_info']['server']['ldap_host'];
	}

	private static function populateWorkflow() {

		$values = self::loadFromDb();

		self::$_configs['workflow']['intranet_subnetworks'] = $values['intranet_subnetworks'];

		self::$_configs['workflow']['db']['name'] = $values['database_name'];
		self::$_configs['workflow']['db']['host'] = $values['database_host'];
		self::$_configs['workflow']['db']['port'] = $values['database_port'];
		self::$_configs['workflow']['db']['admin_user'] = $values['database_admin_user'];
		self::$_configs['workflow']['db']['admin_password'] = $values['database_admin_password'];
		self::$_configs['workflow']['db']['type'] = $values['database_type'];

		self::$_configs['workflow']['galaxia']['db']['name'] = $values['workflow_database_name'];
		self::$_configs['workflow']['galaxia']['db']['host'] = $values['workflow_database_host'];
		self::$_configs['workflow']['galaxia']['db']['port'] = $values['workflow_database_port'];
		self::$_configs['workflow']['galaxia']['db']['user'] = $values['workflow_database_user'];
		self::$_configs['workflow']['galaxia']['db']['password'] = $values['workflow_database_password'];
		self::$_configs['workflow']['galaxia']['db']['type'] = $values['workflow_database_type'];

		self::$_configs['workflow']['ldap']['host'] = $values['ldap_host'];
		self::$_configs['workflow']['ldap']['user'] = $values['ldap_user'];
		self::$_configs['workflow']['ldap']['password'] = $values['ldap_password'];
		self::$_configs['workflow']['ldap']['follow_referrals'] = $values['ldap_follow_referrals'];
	}

	private static function populateExpresso() {}


	private static function loadFromDb() {

		/* */
		$config = &Factory::newInstance('config', 'workflow');
		$values = $config->read_repository();

		/*
		foreach ($values as $key => $value) {
			self::$_configs[$key] = $value;
		}
		self::$loaded_from_db = true;
		*/
		return $values;
	}
}

?>
